package za.co.enerweb.entity;

import java.io.Serializable;
import javax.persistence.*;

import java.util.Date;

import javax.persistence.Entity;
import javax.persistence.Table;

@Entity

@NamedQueries({
    @NamedQuery(name = "TouProfile.findAll", query = "SELECT ERROR HERE !!!! t FROM TouProfile t"),
    @NamedQuery(name = "TouProfile.countAll", query = "SELECT count(t) FROM TouProfile t"),
    @NamedQuery(name = "TouProfile.findByIntervalMinLength", query = "SELECT t FROM TouProfile t WHERE t.intervalMinLength = :intervalMinLength"),
    //@NamedQuery(name = "TouProfile.findByTouName", query = "SELECT t FROM TouProfile t WHERE t.touName = :touName"),
    @NamedQuery(name = "TouProfile.findByTouDate", query = "SELECT t FROM TouProfile t WHERE t.touDate = :touDate"),
    @NamedQuery(name = "TouProfile.findByDateTime", query = "SELECT t FROM TouProfile t WHERE t.dateTime = :dateTime"),
    @NamedQuery(name = "TouProfile.findByWeekday", query = "SELECT t FROM TouProfile t WHERE t.weekday = :weekday"),
    @NamedQuery(name = "TouProfile.findByDemandPeriodCode", query = "SELECT t FROM TouProfile t WHERE t.demandPeriodCode = :demandPeriodCode"),
    @NamedQuery(name = "TouProfile.findBySeasonCode", query = "SELECT t FROM TouProfile t WHERE t.seasonCode = :seasonCode"),
    @NamedQuery(name = "TouProfile.findByDemandCode", query = "SELECT t FROM TouProfile t WHERE t.demandCode = :demandCode"),
    @NamedQuery(name = "TouProfile.findByHolidayName", query = "SELECT t FROM TouProfile t WHERE t.holidayName = :holidayName"),

    @NamedQuery(name="findProfileForInterval", query="SELECT e.demandCode FROM TouProfile e WHERE e.id.touDate = :tou_date_input and e.id.touName = :tou_name_input and e.id.dateTime = :tou_date_time_input and e.id.intervalMinLength = :tou_interval_input") })

@Table(name="TEST")
public class Test implements Serializable {
	private static final long serialVersionUID = 1L;



	@EmbeddedId
	private TouProfilePK id;

	@Column(name="DEMAND_CODE", length=30)
	private String demandCode;

	@Column(name="DEMAND_PERIOD_CODE", length=30)
	private String demandPeriodCode;

	@Column(name="HOLIDAY_NAME", length=30)
	private String holidayName;

	@Column(name="SEASON_CODE", nullable=false, length=30)
	private String seasonCode;

	@Column(nullable=false, length=3)
	private String weekday;

    public Test() {
    }


	public TouProfilePK getId() {
		return id;
	}


	public void setId(TouProfilePK id) {
		this.id = id;
	}


	public String getDemandCode() {
		return this.demandCode;
	}

	public void setDemandCode(String demandCode) {
		this.demandCode = demandCode;
	}

	public String getDemandPeriodCode() {
		return this.demandPeriodCode;
	}

	public void setDemandPeriodCode(String demandPeriodCode) {
		this.demandPeriodCode = demandPeriodCode;
	}

	public String getHolidayName() {
		return this.holidayName;
	}

	public void setHolidayName(String holidayName) {
		this.holidayName = holidayName;
	}


	public String getSeasonCode() {
		return this.seasonCode;
	}

	public void setSeasonCode(String seasonCode) {
		this.seasonCode = seasonCode;
	}


	public String getWeekday() {
		return this.weekday;
	}

	public void setWeekday(String weekday) {
		this.weekday = weekday;
	}

	@Override
	public int hashCode() {
		final int prime = 31;
		int result = 1;
		result = prime * result + ((id == null) ? 0 : id.hashCode());
		return result;
	}


	@Override
	public boolean equals(Object obj) {
		if (this == obj)
			return true;
		if (obj == null)
			return false;
		if (getClass() != obj.getClass())
			return false;
		Test other = (Test) obj;
		if (id == null) {
			if (other.id != null)
				return false;
		} else if (!id.equals(other.id))
			return false;
		return true;
	}
}

